<template>
  <div class="app-container">
    <el-form v-show="showSearch" ref="queryForm" :inline="true" :model="queryParams" label-width="68px">
      <el-form-item label="楼栋名称" prop="buildingName">
        <el-input
          v-model="queryParams.buildingName"
          clearable
          placeholder="请输入楼栋名称"
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="状态" prop="isValid">
        <el-input
          v-model="queryParams.isValid"
          clearable
          placeholder="请输入状态"
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button icon="el-icon-search" size="mini" type="cyan" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
        <el-button
          v-hasPermi="['basis:locationInfo:add']"
          icon="el-icon-plus"
          size="mini"
          type="primary"
          @click="handleAdd"
        >新增
        </el-button>
        <el-button
          v-hasPermi="['basis:locationInfo:edit']"
          :disabled="single"
          icon="el-icon-edit"
          size="mini"
          type="success"
          @click="handleUpdate"
        >修改
        </el-button>
        <el-button
          v-hasPermi="['basis:locationInfo:remove']"
          :disabled="multiple"
          icon="el-icon-delete"
          size="mini"
          type="danger"
          @click="handleDelete"
        >删除
        </el-button>
      </el-form-item>
    </el-form>

    <el-table ref="multipleTable" v-loading="loading"
              :data="locationInfoList" border stripe tooltip-effect="light" @row-click="handleRowClick"
              @selection-change="handleSelectionChange"
    >
      <el-table-column align="center" type="selection" width="55"/>
      <el-table-column align="center" label="楼栋名称" prop="buildingName"/>
      <el-table-column align="center" label="拼音码" prop="pyCode"/>
      <el-table-column align="center" label="总楼层数" prop="floorNumber"/>
      <el-table-column :formatter="isValidFormat" align="center" label="状态" prop="isValid"/>
    </el-table>

    <pagination
      v-show="total>0"
      :limit.sync="queryParams.pageSize"
      :page.sync="queryParams.pageNum"
      :total="total"
      @pagination="getList"
    />

    <!-- 添加或修改楼栋信息对话框 -->
    <el-dialog :title="title" :visible.sync="open" append-to-body width="500px">
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="组织机构" prop="orgId">
          <el-select
            v-model="form.orgId"
            clearable
            placeholder="请选择机构"
          >
            <el-option
              :key="0"
              :label="'全部'"
              :value="''"
            />
            <el-option
              v-for="item in orgList"
              :key="item.id"
              :label="item.orgName"
              :value="item.orgCode"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="院区" prop="yardId">
          <el-select
            v-model="form.yardId"
            clearable
            placeholder="请选择院区"
          >
            <el-option
              :key="0"
              :label="'全部'"
              :value="''"
            />
            <el-option
              v-for="item in yardList"
              :key="item.id"
              :label="item.yardName"
              :value="item.yardCode"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="楼栋名称" prop="buildingName">
          <el-input v-model="form.buildingName" placeholder="请输入楼栋名称"/>
        </el-form-item>
        <el-form-item label="总楼层数" prop="floorNumber">
          <el-input v-model="form.floorNumber" placeholder="请输入总楼层数"/>
        </el-form-item>
        <el-form-item label="状态" prop="isValid">
          <el-select v-model="form.isValid" placeholder="请选择状态">
            <el-option
              v-for="dict in isValidOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="parseInt(dict.dictValue)"
            ></el-option>
          </el-select>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listLocationInfo,
  getLocationInfo,
  delLocationInfo,
  addLocationInfo,
  updateLocationInfo,
  exportLocationInfo
} from '@/api/basis/locationInfo'
import { listOrg } from '@/api/system/org'
import { listYard } from '@/api/basis/yard'
import vPinyin from '@/utils/vue-py'//拼音码转换
export default {
  name: 'LocationInfo',
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 楼栋信息表格数据
      locationInfoList: [],
      // 弹出层标题
      title: '',
      // 是否显示弹出层
      open: false,
      // 状态字典
      isValidOptions: [],
      //机构
      orgList: [],
      //院区
      yardList: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        orgId: null,
        yardId: null,
        buildingName: null,
        isValid: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {}
    }
  },
  created() {
    this.getList()
    this.getDicts('state_type').then(response => {
      this.isValidOptions = response.data
    })
    listOrg({ isValid: 1 }).then(response => {
      this.orgList = response.rows
    })
    listYard({ isValid: 1 }).then(response => {
      this.yardList = response.rows
    })
  },
  methods: {
    handleRowClick(row, column, event) {
      this.$refs.multipleTable.toggleRowSelection(row)
    },
    /** 查询楼栋信息列表 */
    getList() {
      this.loading = true
      listLocationInfo(this.queryParams).then(response => {
        this.locationInfoList = response.rows
        this.total = response.total
        this.loading = false
      })
    },
    /** 机构信息 */
    orgInfoQuery(row, column) {
      let id = row.orgId
      for (var i = 0; i < this.orgList.length; i++) {
        if (id == this.orgList[i].orgCode) {
          return this.orgList[i].orgName
        }
      }
      return ''
    },
    /** 院区信息 */
    yardInfoQuery(row, column) {
      let id = row.yardId
      for (var i = 0; i < this.yardList.length; i++) {
        if (id == this.yardList[i].yardCode) {
          return this.yardList[i].yardName
        }
      }
      return ''
    },
    // 状态字典翻译
    isValidFormat(row, column) {
      return this.selectDictLabel(this.isValidOptions, row.isValid)
    },
    // 取消按钮
    cancel() {
      this.open = false
      this.reset()
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        orgId: null,
        yardId: null,
        buildingName: null,
        pyCode: null,
        floorNumber: null,
        isValid: null,
        createdById: null,
        createdByName: null,
        createdAt: null,
        updatedById: null,
        updatedByName: null,
        updatedAt: null
      }
      this.resetForm('form')
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm('queryForm')
      this.handleQuery()
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset()
      this.open = true
      this.title = '添加楼栋信息'
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset()
      const id = row.id || this.ids
      getLocationInfo(id).then(response => {
        this.form = response.data
        this.open = true
        this.title = '修改楼栋信息'
      })
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs['form'].validate(valid => {
        if (valid) {
          //自动转换拼音码
          if (this.form.buildingName != null && this.form.buildingName != '') {
            this.form.pyCode = vPinyin.chineseToPinYin(this.form.buildingName)
          }
          if (this.form.id != null) {
            updateLocationInfo(this.form).then(response => {
              this.msgSuccess('修改成功')
              this.open = false
              this.getList()
            })
          } else {
            addLocationInfo(this.form).then(response => {
              this.msgSuccess('新增成功')
              this.open = false
              this.getList()
            })
          }
        }
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids
      this.$confirm('是否确认删除楼栋信息编号为"' + ids + '"的数据项?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(function() {
        return delLocationInfo(ids)
      }).then(() => {
        this.getList()
        this.msgSuccess('删除成功')
      })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams
      this.$confirm('是否确认导出所有楼栋信息数据项?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(function() {
        return exportLocationInfo(queryParams)
      }).then(response => {
        this.download(response.msg)
      })
    }
  }
}
</script>
